﻿using Database;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Type = Database.Type;

namespace View
{
	public partial class DateForm : Form
	{
		public int? DateId;
		private Abstracts db;
		public DateForm(Abstracts abstracts)
		{
			InitializeComponent();
			db = abstracts;
		}

		private void button1_Click(object sender, EventArgs e)
		{
			try
			{
				if (DateId.HasValue)
				{
					db.UpdateData(new()
					{
						Id = DateId.Value,
						dateTime = dateTimePicker1.Value,
						userId = (comboBoxUser.SelectedItem as User).Id,
						typeId = (comboBoxType.SelectedItem as Type).Id,
					});
				}
				else
				{
					db.CreateData(new()
					{
						dateTime = dateTimePicker1.Value,
						userId = (comboBoxUser.SelectedItem as User).Id,
						typeId = (comboBoxType.SelectedItem as Type).Id,
					});
				}
				DialogResult = DialogResult.OK;
				Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			Close();
		}

		private void LoadData()
		{
			try
			{
				var users = db.GetUsers();
				var types = db.GetTypes();
				comboBoxUser.DataSource = users;
				comboBoxType.DataSource = types;
				
				comboBoxUser.DisplayMember = "name";
				comboBoxType.DisplayMember = "title";
				comboBoxUser.ValueMember = "Id";
				comboBoxType.ValueMember = "Id";

			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void DateForm_Load(object sender, EventArgs e)
		{
			LoadData();
		}
	}
}
