﻿using Database;


namespace View
{
	public partial class DatesForm : Form
	{
		private readonly Abstracts db;
		public DatesForm(Abstracts abstracts)
		{
			InitializeComponent();
			db = abstracts;
		}

		private void buttonDesc_Click(object sender, EventArgs e)
		{
			if (dataGridView1.SelectedRows.Count == 1)
			{
				var service = Program.ServiceProvider?.GetService(typeof(DescriptionForm));
				if (service is DescriptionForm form)
				{
					form.id = Convert.ToInt32(dataGridView1.SelectedRows[0].Cells["Id"].Value);
					if (form.ShowDialog() == DialogResult.OK)
					{
						LoadData();
					}
				}
			}
		}

		private void buttonUpdate_Click(object sender, EventArgs e)
		{
			if (dataGridView1.SelectedRows.Count == 1) {
				var service = Program.ServiceProvider?.GetService(typeof(DateForm));
				if (service is DateForm form)
				{
					form.DateId = Convert.ToInt32(dataGridView1.SelectedRows[0].Cells["Id"].Value);
					if (form.ShowDialog() == DialogResult.OK)
					{
						LoadData();
					}
				}
			}
		}
		private void buttonDelete_Click(object sender, EventArgs e)
		{
			if (dataGridView1.SelectedRows.Count == 1)
			{
				try
				{
					int id = Convert.ToInt32(dataGridView1.SelectedRows[0].Cells["Id"].Value);
					db.DeleteData(id);
					LoadData();
				}
				catch (Exception ex)
				{
					MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}

		private void buttonReload_Click(object sender, EventArgs e)
		{
			LoadData();
		}

		private void buttonCreate_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(DateForm));
			if (service is DateForm form)
			{
				if (form.ShowDialog() == DialogResult.OK)
				{
					LoadData();
				}
			}
		}

		private void DatesForm_Load(object sender, EventArgs e)
		{
			LoadData();
		}
		private void LoadData()
		{
			try
			{
				var list = db.GetDatas();
				dataGridView1.DataSource = list;
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
		
	}
}
