﻿using Database;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace View
{
	public partial class InviteForm : Form
	{
		public int DateId;
		private Abstracts db;
		public InviteForm(Abstracts abstracts)
		{
			InitializeComponent();
			db = abstracts;
		}

		private void button1_Click(object sender, EventArgs e)
		{
			try {
				var item = comboBox1.SelectedItem as User;
				if (item != null)
				{
					db.CreateInvite(new()
					{
						userId = item.Id,
						typeId = DateId
					});
				}
				DialogResult = DialogResult.OK;
				Close();
			} 
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			DialogResult = DialogResult.Cancel; Close();
		}

		private void InviteForm_Load(object sender, EventArgs e)
		{
			try
			{
				var list = db.GetUsers();
				comboBox1.DataSource = list;
				comboBox1.DisplayMember = "name";
				comboBox1.ValueMember = "Id";
			}
			catch (Exception ex) 
			{
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
	}
}
