using Microsoft.Extensions.DependencyInjection;
using Database;
using System;

namespace View
{
	public static class Program
	{
		private static ServiceProvider? _serviceProvider;
		public static ServiceProvider? ServiceProvider => _serviceProvider;
		[STAThread]
		public static void Main()
		{
			ApplicationConfiguration.Initialize();
			var services = new ServiceCollection();
			ConfigureServices(services);
			_serviceProvider = services.BuildServiceProvider();
			Application.Run(_serviceProvider.GetRequiredService<MainForm>());
		}
		private static void ConfigureServices(ServiceCollection services)
		{
			services.AddTransient<Abstracts, Implements>();
			services.AddTransient<MainForm>();
			services.AddTransient<TypeForm>();
			services.AddTransient<TypesForm>();
			services.AddTransient<InvitedForm>();
			services.AddTransient<InviteForm>();
			services.AddTransient<DatesForm>();
			services.AddTransient<DateForm>();
			services.AddTransient<DescriptionForm>();
			services.AddTransient<UsersForm>();
			services.AddTransient<UserForm>();


		}
	}
}